#ifndef _WSC_H_
#define _WSC_H_

#pragma pack(push, 1)

#define WSC_WLAN_UDP_PORT			38000
#define WSC_WLAN_UDP_ADDR			"127.0.0.1"

#define WSC_WLAN_DATA_MAX_LENGTH		1024

#define WSC_IE_TYPE_SET_BEACON_IE     		1
#define WSC_IE_TYPE_SET_PROBE_REQUEST_IE	2
#define WSC_IE_TYPE_SET_PROBE_RESPONSE_IE	3
#define WSC_IE_TYPE_BEACON_IE_DATA		4
#define WSC_IE_TYPE_PROBE_REQUEST_IE_DATA	5
#define WSC_IE_TYPE_PROBE_RESPONSE_IE_DATA	6
#define WSC_IE_TYPE_SEND_BEACONS_UP		7
#define WSC_IE_TYPE_SEND_PR_RESPS_UP		8
#define WSC_IE_TYPE_SEND_PROBE_REQUEST		9
#define WSC_IE_TYPE_MAX				10

#define WSC_CONFIGURED				0x01
#define WSC_ENABLED				0x02
#define WSC_BEACON_IE_ENABLED			0x03
#define WSC_PROBE_RESP_IE_ENABLED		0x08
#define IS_WSC_CONFIGURED(_flags_)		((_flags_) & WSC_CONFIGURED)
#define IS_WSC_ENABLED(_flags_)			((_flags_) & WSC_ENABLED)
#define IS_WSC_BEACON_IE_ENABLED(_flags_)	((_flags_) & WSC_BEACON_IE_ENABLED)
#define IS_WSC_PROBE_RESP_IE_ENABLED(_flags_)	((_flags_) & WSC_PROBE_RESP_IE_ENABLED)

typedef struct wsc_ie_header {
	u8 elemId;
	u8 length;
	u8 oui[4];
} WSC_IE_HEADER;

typedef struct WSC_IE {
	WSC_IE_HEADER hdr;
	u8 data[WSC_WLAN_DATA_MAX_LENGTH];
} WSC_IE;

typedef struct wsc_ie_command_data {
	u8 type;
	u32 length;
	u8 data[];
} WSC_IE_COMMAND_DATA;


int wsc_init(struct hostapd_data *hapd);
int wsc_deinit(struct hostapd_data *hapd);
 
u8 * hostapd_eid_wsc_beacon(struct hostapd_data *hapd, u8 *eid);
u8 * hostapd_eid_wsc_probe_resp(struct hostapd_data *hapd, u8 *eid);
#pragma pack(pop)

#endif // _WSC_H_

