#ifndef _EAP_WSC_H_
#define _EAP_WSC_H_

#pragma pack(push, 1)

#define WSC_RECVBUF_SIZE	2048

typedef enum
{
	WSC_Start = 1,
	WSC_ACK,
	WSC_NACK,
	WSC_MSG,
	WSC_Done
} opCode;

struct eap_wsc_data {
	enum { START, CONTINUE, SUCCESS, FAILURE } state;
	int udpFdEap;
	u8 recvBuf[WSC_RECVBUF_SIZE];
};

#define WSC_NOTIFY_TYPE_BUILD_REQ		1
#define WSC_NOTIFY_TYPE_BUILD_REQ_RESULT	2
#define WSC_NOTIFY_TYPE_PROCESS_REQ		3
#define WSC_NOTIDY_TYPE_PROCESS_RESP		4
#define WSC_NOTIFY_TYPE_PROCESS_RESULT		5

#define WSC_NOTIFY_RESULT_SUCCESS		0x00
#define WSC_NOTIFY_RESULT_FAILURE		0xFF

typedef struct wsc_notify_buildreq_tag {
	u32	id;
	u32	state;
} WSC_NOTIFY_BUILDREQ;

typedef struct wsc_notify_process_buildreq_result_tag {
	u8	result;
} WSC_NOTIFY_BUILDREQ_RESULT;

typedef struct wsc_notify_process_tag {
	u32	state;
} WSC_NOTIFY_PROCESS;

typedef struct wsc_notify_process_result_tag {
	u8	result;
	u8	done;
} WSC_NOTIFY_PROCESS_RESULT;

typedef struct wsc_notify_data_tag {
	u8	type;
	union {
		WSC_NOTIFY_BUILDREQ		bldReq;
		WSC_NOTIFY_BUILDREQ_RESULT	bldReqResult;
		WSC_NOTIFY_PROCESS		process;
		WSC_NOTIFY_PROCESS_RESULT	processResult;
	} u;
	u32	length;	/* length of the data */
} WSC_NOTIFY_DATA;

#pragma pack(pop)

#endif /* _EAP_WSC_H_ */
